/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.payment.action;

import java.util.Date;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.dao.PtCurrentDao;
import jp.mosp.payroll.dto.PtCurrentDto;
import jp.mosp.payroll.payment.vo.StartCalcVo;

/**
 * 給与計算開始画面における処理を行う。<br><br>
 * 以下のコマンドを扱う。
 * <ul><li>
 * {@link #CMD_SHOW}
 * </li><li>
 * {@link #CMD_EXECUTE}
 * </li><li>
 * {@link #CMD_FORCE}
 * </li></ul>
 */
public class StartCalcAction extends PayrollAction {
	
	/**
	 * 画面表示コマンド。<br><br>
	 * 最新の給与計算終了済年月を取得し、その翌月をデフォルトで表示する。<br>
	 * もし給与計算中の年月があった場合は、その月を表示し警告する。<br>
	 */
	public static final String	CMD_SHOW	= "P1200";
	
	/**
	 * 処理実行コマンド。<br><br>
	 * 指定された計算年月に対して、計算開始状態でデータを作成する。<br>
	 * 但し、指定された計算年月が既に計算完了状態にある場合は警告する。<br>
	 */
	public static final String	CMD_EXECUTE	= "P1205";
	
	/**
	 * 強制処理実行コマンド。<br><br>
	 * 既に計算終了している計算年月に対して、再度計算開始状態にする。<br>
	 */
	public static final String	CMD_FORCE	= "P1206";
	

	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public StartCalcAction() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new StartCalcVo();
	}
	
	/**
	 * アクション。<br>
	 * 詳細は、クラス説明を参照。<br>
	 */
	public void action() throws Exception {
		// VO取得及び設定
		prepareVo();
		if (cmd.equals(CMD_SHOW)) {
			// 画面表示
			show();
		} else if (cmd.equals(CMD_EXECUTE)) {
			// 処理実行
			execute(false);
		} else if (cmd.equals(CMD_FORCE)) {
			// 強制処理実行
			execute(true);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 画面表示処理を行う。<br>
	 * @throws Exception 
	 */
	@Override
	public void show() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		StartCalcVo vo = (StartCalcVo)getVo();
		// システム日付取得
		Date sysDate = new Date();
		// プルダウンアイテム設定
		vo.setPitYear(getYearArray(PayrollConst.DEFAULT_CURRENT_YEAR, MospUtility.getYear(sysDate) + 1));
		vo.setPitMonth(getMonthArray());
		// 計算開始情報確認
		checkCalcStrat();
		// DAO準備
		PtCurrentDao dao = new PtCurrentDao(cfg, cmd, aspUser, user, conn);
		// 最新計算完了年月取得
		PtCurrentDto dto = dao.findLatest(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT, PayrollConst.CURRENT_END);
		// VOフィールド設定
		if (dto != null) {
			Date calcDate = MospUtility.addMonth(dto.getCalcDate(), 1);
			vo.setPltYear(MospUtility.getYear(calcDate));
			vo.setPltMonth(MospUtility.getMonth(calcDate));
		} else {
			vo.setPltYear(MospUtility.getYear(sysDate));
			vo.setPltMonth(MospUtility.getMonth(sysDate));
		}
		// 画面モード設定
		vo.setMode(0);
	}
	
	/**
	 * 給与計算開始処理を行う。<br>
	 * @param isForce 強制実行フラグ
	 * @throws Exception 
	 */
	private void execute(boolean isForce) throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		StartCalcVo vo = (StartCalcVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// 対象年月取得
		Date targetMonth = getTargetMonth();
		// 計算開始情報確認
		checkCalcStrat();
		// 計算状態確認
		if (!isForce) {
			checkCalcState();
		}
		// DAO準備
		PtCurrentDao dao = new PtCurrentDao(cfg, cmd, aspUser, user, conn);
		// 処理対象確認
		PtCurrentDto dto = dao.findForUpdate(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT, targetMonth);
		// 処理対象が存在する場合
		if (dto == null) {
			// 挿入データ作成
			dto = new PtCurrentDto();
			dto.setOfficeCode(PayrollConst.OFFICE_ALL);
			dto.setCalcType(PayrollConst.CALC_PAYMENT);
			dto.setCalcDate(targetMonth);
			dto.setCurrentStatus(PayrollConst.CURRENT_START);
			// 挿入
			dao.insert(dto);
		} else {
			// DTO変更
			dto.setCurrentStatus(PayrollConst.CURRENT_START);
			// 更新
			dao.update(dto);
		}
		// コミット
		commit();
		// メッセージ設定
		setMessage(MospUtility.getMessage(msg, "IP1200", MospUtility.getDateString(targetMonth,
				PayrollConst.FORMAT_YEAR_MONTH)));
		// 次コマンド設定(勤怠データ取込画面へ)
		setNextCmd(ImportTimeAction.CMD_SHOW);
	}
	
	/**
	 * 計算中情報を確認する。<br>
	 * @throws Exception 
	 */
	private void checkCalcStrat() throws Exception {
		// VO取得
		StartCalcVo vo = (StartCalcVo)getVo();
		// 計算中情報取得
		Date current = getCurrent(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT);
		// 計算中情報確認
		if (current != null) {
			// VOフィールド設定
			vo.setPltYear(MospUtility.getYear(current));
			vo.setPltMonth(MospUtility.getMonth(current));
			// 画面モード設定
			vo.setMode(1);
			// 警告メッセージ設定
			String strDate = MospUtility.getDateString(current, PayrollConst.FORMAT_YEAR_MONTH);
			vo.addErrMessage(MospUtility.getMessage(msg, "WP1200", strDate));
			// 例外スロー
			throw new MospException(MospConst.EX_PARAMS_INVALID);
		}
	}
	
	/**
	 * 計算状態を確認する。<br>
	 * @throws Exception 
	 */
	private void checkCalcState() throws Exception {
		// VO取得
		StartCalcVo vo = (StartCalcVo)getVo();
		// DAO準備
		PtCurrentDao dao = new PtCurrentDao(cfg, cmd, aspUser, user, conn);
		// 対象年月取得
		Date targetMonth = getTargetMonth();
		// 処理対象確認
		PtCurrentDto dto = dao.findForKey(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT, targetMonth);
		if (dto == null) {
			return;
		}
		// 計算状態確認
		if (dto.getCurrentStatus() == PayrollConst.CURRENT_END) {
			// 画面モード設定
			vo.setMode(2);
			// 警告メッセージ設定
			String strDate = MospUtility.getDateString(targetMonth, PayrollConst.FORMAT_YEAR_MONTH);
			vo.addErrMessage(MospUtility.getMessage(msg, "WP1201", strDate));
			// 例外スロー
			throw new MospException(MospConst.EX_PARAMS_INVALID);
		}
	}
	
	/**
	 * 操作対象年月を取得する。<br>
	 * @return 操作対象月
	 */
	private Date getTargetMonth() {
		// VO取得
		StartCalcVo vo = (StartCalcVo)getVo();
		// 対象年月取得
		return getDate(vo.getPltYear(), vo.getPltMonth(), PayrollConst.TIME_DEFAULT_DAY);
	}
	
}
